(defun c:zc(/ Center_PT RTN READTYP scale)
  (setq cmdecho_old (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)
  (setq scale 2)
  (princ "\nLeft Button to Zoom In \\ Right Button to Zoom Out")
  (princ "\nCurrent Zoom Scale : ")(princ scale)
  (princ "\nPick Center Point: ")
  (setq Center_PT (car (cdr (grread t))))
  (Update_Block "zoomc" Center_PT)
  (while Center_PT
   (setq RTN (GrRead 1 4 1)
	 READTYP (car RTN))
   (cond ((= READTYP 5)
	 (setq Next_PT (cadr RTN))
	 (if (> (distance Center_PT Next_PT) 0.01)
	   (progn
	     (setq Center_PT Next_PT)
	     (Update_Block "zoomc" Center_PT)
	   )
	 );endif
	) 
        ((= READTYP 3)
         (setq Center_PT (cadr RTN))
	 (Erase_Block "zoomc")
	 (command "zoom" "c" Center_PT "")
	 (command "zoom" "s" (strcat (rtos scale 2 2) "x"))
	 (setq Center_PT nil)
	)
        ((= (car RTN) 25)  
         (setq RTN (grread t))
	 (setq Center_PT (cadr RTN))
	 (Erase_Block "zoomc")
	 (command "zoom" "c" Center_PT "")
	 (command "zoom" "s" (strcat (rtos (/ 1 (float scale)) 2 8) "x"))
	 (setq Center_PT nil)
	)
    );cond
  );while
 (setvar "CMDECHO" cmdecho_old)
 (princ)
)
;;;;;;
(defun Update_Block(blkname Insert_PT / ss idx ed)
  (if (not (ssget "x" '((0 . "INSERT")(2 . "zoomc"))))
    (command "-insert" blkname Insert_PT (* 0.1 (getvar "VIEWSIZE")) "" "")
    (progn
      (setq ss (ssget "x" '((0 . "INSERT")(2 . "zoomc"))))
      (if ss
	(progn
	  (setq idx -1)
	  (while (<= (setq idx (1+ idx)) (1- (sslength ss)))
	     (setq ed (entget (ssname ss idx)))
	     (setq ed (subst (list 10 (car Insert_PT)
				      (cadr Insert_PT)
				      (caddr Insert_PT)) (assoc 10 ed) ed))
	     (entmod ed)
	  )
	)
      )
     )
  )
)
;;;
(defun Erase_Block(blkname / idx ss)
      (setq ss (ssget "x" '((0 . "INSERT")(2 . "zoomc"))))
      (if ss
	(progn
	  (setq idx -1)
	  (while (<= (setq idx (1+ idx)) (1- (sslength ss)))
	         (entdel (ssname ss idx)))
	)
      )
)
